#!/bin/sh

wait_char_device() {
  local file="$1"; shift
  local wait_seconds="${1:-10}"; shift # 10 seconds as default timeout

  until test $((wait_seconds--)) -eq 0 -o -c "$file" ; do sleep 1; done

  return $((++wait_seconds))
}

do_start() {
  echo "Modem upgrade starting"

  # Wait for modem device to appear
  wait_char_device /dev/cdc-wdm0 30 && {
    echo "Modem device file not found"
    exit 1
  }

  echo "Modem device file found."
  /etc/init.d/netctl stop
  /etc/init.d/ofono stop
  qmi-firmware-update --update --cdc-wdm /dev/cdc-wdm0 /user/wanmodemupgrade/mc7304-generic/SWI9X15C_05.05.58.00.cwe /user/wanmodemupgrade/mc7304-generic/SWI9X15C_05.05.58.00_Generic_005.026_000.nvu
  /etc/init.d/ofono start
  sleep 1
  /etc/init.d/netctl start
  echo "Modem upgrade terminated"

  return 0
}

case "$1" in
  start)
    do_start
    # Self delete
    [ -L ${0} ] && unlink ${0}
  ;;
  *)
    echo "Usage: $0 start" >&2
    exit 1
  ;;
esac

exit 0
